REM
REM  Serial link emulation
REM  This file is part of the ZilogBoy project
REM  Copyright (C) Mateusz Viste 2010
REM

REM  FF02 is the serial control address
REM    Bit 7 - if set, the game wants to interact with serial link
REM    Bit 0 - Clock source selection (0 = external   1 = internal)

REM  FF01 is the serial data buffer (for in & out operations)

SUB CheckSerialLink()   ' For now, this procedure just fakes a Serial GB interface which is connected nowhere
  IF IoRegisters(&hFF02) AND &b10000000 > 0 THEN  ' The game tries to send some stuff out
    IF IoRegisters(&hFF02) AND &b00000001 > 0 THEN  ' If external clock is selected, ignore, otherwise let's see
      IoRegisters(&hFF01) = &hFF   ' FF means no data has been received
      ' Once serial handling done, request serial interrupt (INT 58), via bit 3 of FF0F
      IoRegisters(&hFF0F) = IoRegisters(&hFF0F) OR &b00001000
    END IF
  END IF
END SUB
